/*
 * prot_sim_calls.h
 *
 * Copyright (c) 1995 by Jim Goodman
 *
 * ALL RIGHTS RESERVED.
 *
 * This source file is part of the SCI protocol module for the Wisconsin
 * Wind Tunnel, written by Alain K\"agi.
 *
 * ----------------------------------------------------------------------------
 *
 * Build an equivalence table with system call names and their corresponding
 * function implementation in the simulator.
 *
 * Inspired by its dir1sw counterpart.
 *
 * ----------------------------------------------------------------------------
 */

ovh_func("wwt_swap", swap, 6),
ovh_func("wwt_swap_acq", swap_acq, 6),
ovh_func("wwt_swap_rel", swap_rel, 6),
ovh_func("wwt_swap_acq_rel", swap_acq_rel, 6),

ovh_func("_qolb_enqolb", qolb_enqolb, 5),
ovh_func("_qolb_deqolb", qolb_deqolb, 5),
ovh_func("_qolb_deqolb_rel", qolb_deqolb_rel, 5),
ovh_func("_qolb_deqolb_i", qolb_deqolb_i, 5),
ovh_func("_qolb_prefetch", qolb_prefetch, 5),
ovh_func("_qolb_unprefetch", qolb_unprefetch, 5),

ovh_func("_signal_read", signal_read, 5),
ovh_func("_signal_write", signal_write, 6),

ovh_func("_nsynch_read", nsynch_read, 5),
ovh_func("_nsynch_write", nsynch_write, 6),

ovh_func("_nsynch_write_d", nsynch_write_d, 7),

ovh_func("wwt_swap_d", swap_d, 7),
ovh_func("wwt_swap_acq_d", swap_acq_d, 7),
ovh_func("wwt_swap_rel_d", swap_rel_d, 7),
ovh_func("wwt_swap_acq_rel_d", swap_acq_rel_d, 7),

ovh_func("wwt_compare_and_set_d", compare_and_set_d, 9),
ovh_func("wwt_compare_and_set_acq_d", compare_and_set_acq_d, 9),
ovh_func("wwt_compare_and_set_rel_d", compare_and_set_rel_d, 9),
ovh_func("wwt_compare_and_set_acq_rel_d", compare_and_set_acq_rel_d, 9),

  /* overhead values to minimize impact on program, 5 didn't work */
ovh_func("wwt_lockstats_lock_in", wwt_lockstats_lock_in, 3),
ovh_func("wwt_lockstats_lock_out", wwt_lockstats_lock_out, 3),
ovh_func("wwt_lockstats_unlock_in", wwt_lockstats_unlock_in, 3),
ovh_func("wwt_lockstats_unlock_out", wwt_lockstats_unlock_out, 3),
ovh_func("wwt_lockstats_lock_entry_in", wwt_lockstats_lock_entry_in, 3),
ovh_func("wwt_lockstats_lock_entry_out", wwt_lockstats_lock_entry_out, 3),
ovh_func("wwt_lockstats_unlock_entry_in", wwt_lockstats_unlock_entry_in, 3),
ovh_func("wwt_lockstats_unlock_entry_out", wwt_lockstats_unlock_entry_out, 3),
ovh_func("wwt_lockstats_prefetch", wwt_lockstats_prefetch, 3),
ovh_func("wwt_lockstats_unprefetch", wwt_lockstats_unprefetch, 3),

ovh_func("_shared_prefetch", shared_prefetch, 5),
ovh_func("_excl_prefetch", excl_prefetch, 5),
