/*
 * ts_lock.h
 *
 * Copyright (c) 1996 by Jim Goodman
 *
 * ALL RIGHTS RESERVED.
 *
 * This source file is part of the SCI protocol module for the Wisconsin
 * Wind Tunnel, written by Alain K\"agi.
 *
 * ----------------------------------------------------------------------------
 *
 * Test&set lock.
 */

#ifndef _ts_lock_h
#define _ts_lock_h

/*
 * Declare a lock.
 */
#define TS_LOCKDEC(lockname)		int lockname

/*
 * Initialize a lock.
 */
#define TS_LOCKINIT(lockname)		wwt_swap_acq_rel(&(lockname), 0)

/*
 * Calls.
 */
#define TS_LOCK(lockname)		while (wwt_swap_acq(&(lockname), 1)) ;
#define TS_UNLOCK(lockname)		_signal_write(&(lockname), 0)

#define TS_LOCK_ENTRY(lockname)		while (wwt_swap(&(lockname), 1)) ;
#define TS_UNLOCK_ENTRY(lockname)	asm volatile ("");		      \
					(lockname) = 0

#define TS_PREFETCH(lockname)
#define TS_UNPREFETCH(lockname)

#endif _ts_lock_h
