/*
 * tts_lock.h
 *
 * Copyright (c) 1996 by Jim Goodman
 *
 * ALL RIGHTS RESERVED.
 *
 * This source file is part of the SCI protocol module for the Wisconsin
 * Wind Tunnel, written by Alain K\"agi.
 *
 * ----------------------------------------------------------------------------
 *
 * Test&test&set lock.
 */

#ifndef _tts_lock_h
#define _tts_lock_h

/*
 * Declare a lock.
 */
#define TTS_LOCKDEC(lockname)		volatile int lockname

/*
 * Initialize a lock.
 */
#define TTS_LOCKINIT(lockname)		wwt_swap_acq_rel(&(lockname), 0)

/*
 * Calls.
 */
#ifndef LOCKSTATS
#define TTS_LOCK(lockname)		while ((lockname)		      \
					       || wwt_swap_acq(&(lockname),1));
#else
#define TTS_LOCK(lockname)		while ((int)_signal_read(&(lockname))  \
					       || wwt_swap_acq(&(lockname),1));
#endif
#define TTS_UNLOCK(lockname)		_signal_write(&(lockname), 0)

#define TTS_LOCK_ENTRY(lockname)	while ((lockname)		      \
					       || wwt_swap(&(lockname), 1)) ;
#define TTS_UNLOCK_ENTRY(lockname)	asm volatile ("");		      \
					(lockname) = 0

#define TTS_PREFETCH(lockname)
#define TTS_UNPREFETCH(lockname)

#endif _tts_lock_h
