/*
 * with_lock.h
 *
 * Copyright (c) 1996 by Jim Goodman
 *
 * ALL RIGHTS RESERVED.
 *
 * This source file is part of the SCI protocol module for the Wisconsin
 * Wind Tunnel, written by Alain K\"agi.
 *
 * ----------------------------------------------------------------------------
 *
 * Annotations for Nagi's compiler.
 */

#ifndef _with_lock_h
#define _with_lock_h

/*
 * Declare a lock.
 */
#define WITH_LOCKDEC(lockname)		volatile int lockname

/*
 * Initialize a lock.
 */
#define WITH_LOCKINIT(lockname)		_qolb_initialize(&(lockname))

/*
 * Calls.
 */
#define WITH_LOCK(lockname)		with_annot(&(lockname)) {
#define WITH_UNLOCK(lockname)		}

#define WITH_LOCK_ENTRY(lockname)	with(&(lockname)) {
#define WITH_UNLOCK_ENTRY(lockname)	}

#define WITH_PREFETCH(lockname)
#define WITH_UNPREFETCH(lockname)

#endif _with_lock_h
